<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="算法类型" prop="type">
        <el-select v-model="queryParams.type" placeholder="请选择算法类型" clearable filterable @change=changeQueryType()>
          <el-option
            v-for="dict in dict.type.extract_type"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="算法子类型" prop="subTypeId">
        <el-select
          v-model="queryParams.subTypeId"
          placeholder="请选择算法子类型"
          clearable
          filterable
        >
          <el-option
            v-for="item in algoTypeList"
            :key="item.id"
            :label="item.name"
            :value="item.id"
          >
          </el-option>
        </el-select>
      </el-form-item>
      <el-form-item label="名称" prop="name">
        <el-input
          v-model="queryParams.name"
          placeholder="请输入名称"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <!-- <el-form-item label="开始时间" prop="startTime">
        <el-date-picker clearable
          v-model="queryParams.startTime"
          type="date"
          value-format="yyyy-MM-dd"
          placeholder="请选择开始时间">
        </el-date-picker>
      </el-form-item>
      <el-form-item label="完成时间" prop="completedTime">
        <el-date-picker clearable
          v-model="queryParams.completedTime"
          type="date"
          value-format="yyyy-MM-dd"
          placeholder="请选择完成时间">
        </el-date-picker>
      </el-form-item>
      <el-form-item label="耗时(s)" prop="costSecond">
        <el-input
          v-model="queryParams.costSecond"
          placeholder="请输入耗时(s)"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item> -->
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['algoManager:algorithm:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['algoManager:algorithm:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['algoManager:algorithm:remove']"
        >删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
          :disabled="single"
          @click="handleExport"
          v-hasPermi="['algoManager:algorithm:export']"
        >导出</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-mouse"
          size="mini"
          @click="handleRun"
          v-hasPermi="['algoManager:algorithm:run']"
        >算法运行</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList()"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="algorithmList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="编号" align="center" prop="id" />
      <el-table-column label="算法类型" align="center" prop="type">
        <template slot-scope="scope">
          <dict-tag :options="dict.type.extract_type" :value="scope.row.type"/>
        </template>
      </el-table-column>
      <el-table-column label="算法子类型" align="center" prop="algoSubName" />
      <el-table-column label="名称" align="center" prop="name" />
      <el-table-column label="运行状态" align="center" prop="status">
        <template slot-scope="scope">
          <dict-tag :options="dict.type.algo_run_status" :value="scope.row.status"/>
        </template>
      </el-table-column>
      <el-table-column label="开始时间" align="center" prop="startTime" width="180">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.startTime) }}</span>
        </template>
      </el-table-column>
      <el-table-column label="完成时间" align="center" prop="completedTime" width="180">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.completedTime) }}</span>
        </template>
      </el-table-column>
      <el-table-column label="耗时(s)" align="center" prop="costSecond" />
      <el-table-column label="错误日志" align="center" prop="error" />
      <el-table-column label="备注" align="center" prop="remark" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            v-show="scope.row.status == 0"
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['algoManager:algorithm:edit']"
          >修改</el-button>
          <el-button
            v-show="scope.row.status == 2"
            size="mini"
            type="text"
            icon="el-icon-warning-outline"
            @click="viewResult(scope.row)"
            v-hasPermi="['algoManager:algorithm:edit']"
          >查看结果</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['algoManager:algorithm:remove']"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>
    
    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改算法对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="算法类型" prop="type">
          <el-select v-model="form.type" placeholder="请选择算法类型" clearable filterable :disabled="form.status == 2" @change='changeFormType()'>
            <el-option
              v-for="dict in dict.type.extract_type"
              :key="dict.value"
              :label="dict.label"
              :value="dict.value"
            ></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="算法子类型" prop="subTypeId">
          <el-select
            v-model="form.subTypeId"
            placeholder="请选择算法子类型"
            clearable
            filterable
            :disabled="form.status == 2"
            @change='changeFormSubType()'
          >
            <el-option
              v-for="item in algoTypeList"
              :key="item.id"
              :label="item.name"
              :value="item.id"
            >
            </el-option>
          </el-select>
        </el-form-item>
        <template v-if="form.subTypeId">
          <el-form-item v-for="item in form.ioSubList" :label="item.name" :key="item.id">
            <!-- <file-upload v-model="form.path"/> -->
            <image-preview v-if="form.status == 2 && imageList.includes(item.path.split('.').pop())" :src="item.path" :width="50" :height="50"/>
            <template v-else-if="form.status == 2 && textList.includes(item.path.split('.').pop())">
              <div>
                <!-- 显示文件内容 -->
                <div class="file-content" v-show="fileContent">
                  {{ fileContent }}
                </div>
              </div>
            </template>
            <el-select
              v-else
              v-model="item.uploadId"
              placeholder="请选择文件"
              clearable
              filterable
              :disabled="form.status == 2 || item.type == 2"
            >
              <el-option
                v-for="inputFile in inputFileList"
                :key="inputFile.id"
                :label="inputFile.name"
                :value="inputFile.id"
              >
              </el-option>
            </el-select>
            <template v-if="form.status == 2">
              <el-button
                size="mini"
                type="text"
                icon="el-icon-download"
                @click="download(item.path)"
                v-hasPermi="['data:model:edit']"
              >{{ "下载文件" }}
              </el-button>
            </template>
          </el-form-item>
        </template>
        <el-form-item label="名称" prop="name">
          <el-input v-model="form.name" placeholder="请输入名称" :disabled="form.status == 2"/>
        </el-form-item>
        <el-form-item label="备注" prop="remark">
          <el-input v-model="form.remark" type="textarea" placeholder="请输入内容" :disabled="form.status == 2"/>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button v-show="form.status != 2" type="primary" @click="submitForm">确 定</el-button>
        <el-button v-show="form.status != 2" @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listAlgorithm, getAlgorithmDto, delAlgorithm, addOrUpdateDto, runAlgorithms } from "@/api/algoManager/algorithm";
import { getAlgoSubOption } from "@/api/algoManager/algorithm";
import { getIoSubList } from "@/api/conf/field";
import { getFileList, getInputFileList } from "@/api/algoManager/file";
import axios from 'axios';
import { isExternal } from "@/utils/validate";

export default {
  name: "Algorithm",
  dicts: ['extract_type','algo_run_status'],
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 算法表格数据
      algorithmList: [],
      extractList: [],
      // 算法子类列表
      algorithmSubList: [],
      // 算法特定类列表
      algoTypeList: [],
      // 已上传文件列表
      fileList: [],
      // 输入文件表格数据
      inputFileList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        type: null,
        subTypeId: null,

        name: null,
        dictType: "extract_type",
        startTime: null,
        completedTime: null,
        costSecond: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        subTypeId: [
          { required: true, message: "算法子类型不能为空", trigger: "blur" }
        ],
      },
      typeMap: new Map(),
      imageList: ["jpg", "jpeg", "png", "bmp", "gif"],
      textList: ["txt", "doc", "hlp", "wps"],
      fileContent: '',
    };
  },
  created() {
    this.getList();
    this.getAlgoSubOption();
  },
  activated() {
    this.getList();
    this.getAlgoSubOption();
  },
  methods: {
    /** 查询算法列表 */
    getList() {
      this.loading = true;
      listAlgorithm(this.queryParams).then(response => {
        this.algorithmList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },

    getAlgoSubOption() {
      getAlgoSubOption().then((resp) => {
        this.algorithmSubList = resp.data;
        this.createTypeMap();
        console.info(resp);
      });
    },

    // getFileList() {
    //   getFileList().then((resp) => {
    //     this.fileList = resp.data;
    //     console.info(resp);
    //     console.info(this);
    //   });
    // },

    getInputFileList() {
      getInputFileList(this.form.subTypeId).then((resp) => {
        this.inputFileList = resp.data;
        console.info(resp);
        console.info(this);
      });
    },

    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        type: null,
        subTypeId: null,
        name: null,
        startTime: null,
        completedTime: null,
        costSecond: null,
        createBy: null,
        createTime: null,
        updateBy: null,
        updateTime: null,
        remark: null,
        // 具体算法输入输出文件列表
        ioSubList: []
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加算法";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      getAlgorithmDto(id).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改算法";
        this.algoTypeList = this.typeMap.get(this.form.type);
      });
      console.info(this);
    },
    /** 查看结果按钮操作 */
    viewResult(row) {
      this.reset();
      const id = row.id || this.ids
      getAlgorithmDto(id).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "查看结果";
        this.algoTypeList = this.typeMap.get(this.form.type);
        this.fetchFileContent(this.form.ioSubList);
      });
      console.info(this);
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          addOrUpdateDto(this.form).then(response => {
            this.$modal.msgSuccess("成功");
            this.open = false;
            this.getList();
          });
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$modal.confirm('是否确认删除算法编号为"' + ids + '"的数据项？').then(function() {
        return delAlgorithm(ids);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download('algoManager/algorithm/export', {
        ...this.queryParams
      }, `algorithm_${new Date().getTime()}.xlsx`)
    },
    /** 运行算法按钮操作 */
    handleRun(row) {
      const id = row.id || this.ids
      // debugger
      runAlgorithms(id).then(response => {
        this.$modal.msgSuccess("成功");
        this.getList();
      });
    },
    
    createTypeMap() {
      this.typeMap = new Map();
      for (const algorithmSub of this.algorithmSubList) {
        if(this.typeMap.has(algorithmSub.type)) {
          this.typeMap.get(algorithmSub.type).push({
            id: algorithmSub.id,
            name: algorithmSub.name
          });
        }
        else {
          this.typeMap.set(algorithmSub.type, [{
            id: algorithmSub.id,
            name: algorithmSub.name
          }]);
        }
      }
    },

    changeQueryType() {
      this.queryParams.subTypeId = null;
      this.algoTypeList = this.typeMap.get(this.queryParams.type);
    },

    changeFormType() {
      this.form.subTypeId = null;
      this.algoTypeList = this.typeMap.get(this.form.type);
    },

    changeFormSubType() {
      if(this.form.subTypeId) {
        getIoSubList(this.form.subTypeId, this.form.id).then((resp) => {
          this.form.ioSubList = resp.data;
          console.info(resp);
        });
        this.getInputFileList();
      }
      else {
        this.inputFileList = [];
      }
    },

    download(path) {
      this.$download.resource(path);
    },

    // 拿到文本文件里的内容
    async fetchFileContent(ioSubList) {
      try {
        let filePath;
        for (let item of ioSubList) {
          if (this.textList.includes(item.path.split('.').pop())) {
            filePath = item.path;
          }
        }
        if (filePath) {
          const response = await axios.get(this.realSrc(filePath), { responseType: 'text' });
          this.fileContent = response.data;
        }
        // const response = await axios.get(this.realSrc(filePath), { responseType: 'text' });
        // this.fileContent = response.data;
      } catch (error) {
        console.error("Error fetching the file:", error);
        alert('无法加载文件内容');
      }
    },

    // 通过path得到绝对路径
    realSrc(src) {
      if (!src) {
        return;
      }
      let real_src = src.split(",")[0];
      if (isExternal(real_src)) {
        return real_src;
      }
      return process.env.VUE_APP_BASE_API + real_src;
    },
  }
};
</script>
